unit Imagemap;
{
a part of imagemapper, see http://sickel.net/imagemapper for more info

This software is (c) 2006 Morten Sickel (morten@sickel.net) it is licenced under
the Gnu Public Licence

}


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtDlgs, ExtCtrls, ComCtrls, ActnList,jpeg, Unadd,
  Menus, extactns;

type
  TFoImagemapper = class(TForm)
    OpenPict: TOpenPictureDialog;
    PageControl: TPageControl;
    TSImage: TTabSheet;
    TSImagemap: TTabSheet;
    Memo: TMemo;
    ActionList1: TActionList;
    AcOpenImage: TAction;
    AcFinishMap: TAction;
    Panel1: TPanel;
    LLines: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    SCircle: TShape;
    CBNewWindow: TCheckBox;
    Ediameter: TEdit;
    UpDown1: TUpDown;
    CBShowLine: TCheckBox;
    ScrollBox1: TScrollBox;
    Image: TImage;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenImage1: TMenuItem;
    AcSaveHTML: TAction;
    SaveDialog: TSaveDialog;
    SaveHTML1: TMenuItem;
    AcCompleteHTML: TAction;
    Imagemap1: TMenuItem;
    Finish1: TMenuItem;
    CompleteHTML1: TMenuItem;
    AcContinue: TAction;
    Continue1: TMenuItem;
    AcOpenInBrowser: TAction;
    OpeninBrowser1: TMenuItem;
    AcBrowseURL: TBrowseURL;
    Help1: TMenuItem;
    AcAbout: TAction;
    About1: TMenuItem;
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AcOpenImageExecute(Sender: TObject);
    procedure AcFinishMapExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EdiameterChange(Sender: TObject);
    procedure AcSaveHTMLExecute(Sender: TObject);
    procedure AcCompleteHTMLExecute(Sender: TObject);
    procedure AcContinueExecute(Sender: TObject);
    procedure AcOpenInBrowserExecute(Sender: TObject);
    procedure AcAboutExecute(Sender: TObject);
  private
    imagefile : string;
    htmlfile : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FoImagemapper: TFoImagemapper;

implementation

uses UnAbout;

{$R *.dfm}

procedure TFoImagemapper.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  message,href,title, target: string;
begin
  // Only add points if an image is open and the map is not finished
  if AcFinishMap.enabled THEN
  BEGIN
  Fadd.ShowModal;
  If Fadd.ModalResult<>mrCancel THEN BEGIN
    target:='" ';
    if cbnewwindow.Checked THEN
      target:='" target=_self '; // opens in a new tab/window
    href:=FAdd.EHref.Text;
    title:=FAdd.ETitle.Text;
    message:='<area shape="circle" coords="'+inttostr(X)+','
    +inttostr(Y)+','+ediameter.Text+'" href="'+href+target+'title="'+title+'" />';
    if cbshowline.Checked THEN showmessage(message);
    Memo.Lines.Add(message);
    LLines.Caption:=inttostr(1+strtoint(llines.Caption));
  END;
  END;
end;

procedure TFoImagemapper.AcOpenImageExecute(Sender: TObject);
var
  id,width,height : String;
  position: integer;
begin
if openpict.Execute then
  begin
    imagefile := OpenPict.FileName;
    Image.Picture.LoadFromFile(imagefile);
// opened file. Need some references within the html code, uses the filename
// without directory and with _ for spaces
    position:=lastdelimiter('\:',imagefile);
    delete(imagefile,1,position);
    id:=stringReplace(imagefile,' ','_',[rfReplaceall]);
    id:=id+'_map';
    Memo.Lines.Clear;
    // puts in width and height data in the img
    width:=inttostr(image.Width);
    height:=inttostr(image.Height);
    memo.lines.add('<img src="'+imagefile+'" alt="" usemap="#'+id+
    '" width="'+width+'" height="'+height+'" style="border-style:none" />');
    memo.lines.add('<map id="'+id+'" name="'+id+'">');
    Llines.Caption:='0';
// sets up so things are reasonable for a newly loaded picture
    PageControl.ActivePage:=TSImage;
    AcFinishMap.Enabled:=TRUE;
    acCompleteHTML.Enabled:=FALSE;
    acContinue.Enabled:=FALSE;
    acSaveHTML.enabled:=TRUE;
    acOpenInBrowser.enabled:=FALSE;
    FoImagemapper.Caption:=application.Title+' - '+imagefile;
  end;
end;


// puts in tags that finishes of the imagemap
procedure TFoImagemapper.AcFinishMapExecute(Sender: TObject);
begin
  memo.Lines.add('<area shape="default" nohref="nohref" alt="" />');
  memo.Lines.add('</map>');
  acFinishmap.Enabled:=FALSE;
  acCompleteHTML.Enabled:=TRUE;
  acContinue.Enabled:=TRUE;
end;

procedure TFoImagemapper.FormCreate(Sender: TObject);
begin
// just to be sure, the IDE may leave something
  memo.Lines.Clear;
end;

procedure TFoImagemapper.EdiameterChange(Sender: TObject);
begin
// shows the size of the circle relative to the image
    SCircle.Width:=strtoint(Ediameter.Text)*2;
end;

procedure TFoImagemapper.AcSaveHTMLExecute(Sender: TObject);
var
  index : integer;
  filename: string;
begin
  IF acfinishmap.Enabled THEN
  // things may be messy if the imagemap is not finished of when the file is saved
    if messagedlg('Do you want to finish the imagemap?',mtconfirmation,[mbYes,mbNo],0)=mrYes
    THEN
      AcFinishMap.execute
    ELSE
      exit;
  filename:=imagefile;
  index:=lastdelimiter('.',filename);
  delete(filename,index,length(filename)-index+1);
  Savedialog.FileName:=filename;
  if Savedialog.Execute then
    memo.Lines.SaveToFile(Savedialog.filename);
  htmlfile:=savedialog.filename;
  AcOpenInBrowser.enabled:=TRUE;
end;

procedure TFoImagemapper.AcCompleteHTMLExecute(Sender: TObject);
begin
  memo.Lines.Insert(0,'<html><head><title>'+imagefile+'</title></head><body>');
  memo.Lines.Add('</body></html>');
  AcCompleteHTML.enabled:=FALSE;
end;

procedure TFoImagemapper.AcContinueExecute(Sender: TObject);
begin
  if not (AcCompleteHTML.enabled) THEN
  BEGIN
    memo.Lines.Delete(0);
    memo.lines.Delete(memo.Lines.Count-1);
  END;
  if not (AcFinishMap.enabled) THEN
  BEGIN
    memo.lines.Delete(memo.Lines.Count-1);
    memo.lines.Delete(memo.Lines.Count-1);
  END;
  AcContinue.Enabled:=false;
  AcFinishMap.Enabled:=TRUE;
  acCompleteHTML.enabled:=FALSE;
end;

procedure TFoImagemapper.AcOpenInBrowserExecute(Sender: TObject);
begin
  acBrowseUrl.URL:=htmlfile;
  acBrowseUrl.ExecuteTarget(Sender);
end;

procedure TFoImagemapper.AcAboutExecute(Sender: TObject);
begin
  FoAbout.show;
end;

end.



